Imports System.Net
Imports System.Net.Sockets

Public Class Server : Inherits TCPBase

    Private _Listener As TcpListener

    ' Pro Verbindung(sanfrage) wird ein Client-Objekt generiert, das den 
    '  Datenaustausch dieser Verbindung abwickelt
    Private _Clients As New List(Of Client)

    Public Sub New(ByVal EP As IPEndPoint)
        _Listener = New TcpListener(EP)
        _Listener.ExclusiveAddressUse = False
        _Listener.Start()
        _Listener.BeginAcceptTcpClient(AddressOf EndAccept, Nothing)
    End Sub

    Sub EndAccept(ByVal ar As IAsyncResult)
        If MyBase.IsDisposed Then Return
        With New Client(_Listener.EndAcceptTcpClient(ar))
            AddHandler .ChatMessage, AddressOf Client_ChatMessage
            AddHandler .StatusMessage, AddressOf Client_StatusMessage
            AddHandler .Disposed, AddressOf Client_Disposed
            .AddTo(_Clients)
        End With
        CrossThread.RunGui(AddressOf OnStatusMessage, _
                           New MessageEventargs("TCPClient accepted"))
        _Listener.BeginAcceptTcpClient(AddressOf EndAccept, Nothing)
    End Sub

#Region "_Clients-Ereignisverarbeitung"

    Private Sub Client_Disposed(ByVal Sender As TCPBase)
        ' Den Client fr die beendete Verbindung entfernen
        Sender.RemoveFrom(_Clients)
    End Sub

    Private Sub Client_ChatMessage(ByVal sender As Object, _
                                   ByVal e As MessageEventargs)
        ' Einkommende ChatMessages anzeigen, und an alle versenden
        Send(e.Message)
    End Sub

    Private Sub Client_StatusMessage(ByVal sender As Object, _
                                     ByVal e As MessageEventargs)
        ' Einkommende StatusMessages durchreichen (zur Anzeige)
        OnStatusMessage(e)
    End Sub

#End Region '_Clients-Ereignisverarbeitung

    Public Overrides Sub Send(ByVal Msg As String)
        OnChatMessage(New MessageEventargs(Msg)) ' anzeigen
        For Each C As Client In _Clients    ' an alle versenden
            C.Send(Msg)
        Next
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        _Listener.Stop()
        For i = _Clients.Count - 1 To 0 Step -1
            _Clients(i).Dispose()
        Next
    End Sub

End Class
